import java.awt.Dimension;
import java.awt.Font;
import java.awt.Graphics;
import java.util.Queue;

import javax.swing.JComponent;

/**
 *  A Java Swing component that displays the contents of a queue
 *
 *  @author Nicholas R. Howe, modified by Sara Sheehan
 *  @version February 29, 2016
 */
public class JQueue extends JComponent {
	
    /** For serializing the class */
	private static final long serialVersionUID = 1L;
	
	/** The queue */
    private Queue<Character> queue;

    /** Constructor is requires a queue object */
    public JQueue(Queue<Character> queue) {
        this.queue = queue;
    }

    /**
     *  Draws the queue in the graphics window
     *  @param g The graphics object to draw into
     */
    public void paintComponent(Graphics g) {
    		g.setFont(new Font("Monospace",Font.BOLD,36));
    		
    		// cycle through queue & display entries
    		for (int i = 0; i < this.queue.size(); i++) {
            Character item = this.queue.remove();
            char arr[] = {item};
            g.drawChars(arr,0,1,i*50+12,37);
            this.queue.add(item);
    		}
    }

    /**
     *  The component will look bad if it is sized smaller than this
     *  @returns The minimum dimension
     */
    public Dimension getMinimumSize() {
    		return new Dimension(375,50);
    }

    /**
     *  The component will look best at this size
     *  @returns The preferred dimension
     */
    public Dimension getPreferredSize() {
    		return new Dimension(375,50);
    }
}
